<template>
    <div class="col">
        <template v-if="showDeleteModal.show">
            <div class="modal fade show" style="display: block">
                <div class="modal-dialog">
                    <!-- Modal content-->
                    <div class="modal-content">
                        <div class="modal-header">
                            <h4 class="modal-title">Confirm Deletion!</h4>
                            <a class="close" @click="hideDeleteModal" >&times;</a>
                        </div>
                        <div class="modal-body">
                            <p>You want to remove the Product form Wishlist</p>
                        </div>
                        <div class="modal-footer">
                            <div class="inline-flex justify-center">
                                <button @click="performDeleteAction" class="">
                                    <slot name="deleteModalYesText">
                                        <div>Yes, Absolutely!</div>
                                    </slot>
                                </button>
                                <button @click="hideDeleteModal" class="">
                                    <slot name="deleteModalNoText">
                                        <div>
                                            No, Forget it!
                                        </div>
                                    </slot>
                                </button>
                            </div>
                            <span @click="hideDeleteModal" class="">
                            <svg class="h-6 w-6 text-grey hover:text-grey-darkest" role="button" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20"><title>Close</title><path d="M14.348 14.849a1.2 1.2 0 0 1-1.697 0L10 11.819l-2.651 3.029a1.2 1.2 0 1 1-1.697-1.697l2.758-3.15-2.759-3.152a1.2 1.2 0 1 1 1.697-1.697L10 8.183l2.651-3.031a1.2 1.2 0 1 1 1.697 1.697l-2.758 3.152 2.758 3.15a1.2 1.2 0 0 1 0 1.698z"/></svg>
                        </span>
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-backdrop fade show"></div>
        </template>

        <vuetable ref="vuetable"
                  :http-options = "httpHeaders"
                  :api-url="apiUrl"
                  :fields="fields"
                  :css="css.table"
                  :sort-order="sortOrder"
                  :multi-sort="true"
                  :append-params="moreParams"
                  pagination-path=""
                  @vuetable:cell-clicked="onCellClicked"
                  @vuetable:pagination-data="onPaginationData"
        >
            <template slot="image" slot-scope="props">
                <img :src="props.rowData.display_image" alt="" width="50" height="50">
            </template>
            <template slot="actions" slot-scope="props">
                <button class="btn btn-danger"
                        @click="deleteItemFromWishList(props.rowData.id)">
                    <svg class="svg-sort pl-2 fill-white" viewBox="0 0 7 8" tooltip="Sort Ascending"> <path d="M3 0c-.55 0-1 .45-1 1H1c-.55 0-1 .45-1 1h7c0-.55-.45-1-1-1H5c0-.55-.45-1-1-1H3zM1 3v4.81c0 .11.08.19.19.19h4.63c.11 0 .19-.08.19-.19V3h-1v3.5c0 .28-.22.5-.5.5s-.5-.22-.5-.5V3h-1v3.5c0 .28-.22.5-.5.5s-.5-.22-.5-.5V3h-1z"></path></svg>
                    Remove
                </button>
            </template>
        </vuetable>

        <div class="row vuetable-pagination">
            <div class="col">
                <vuetable-pagination-info ref="paginationInfo"
                                          info-class="pagination-info"
                ></vuetable-pagination-info>
            </div>
            <div class="col">
                <vuetable-pagination ref="pagination"
                                     :css="css.pagination"
                                     @vuetable-pagination:change-page="onChangePage"
                ></vuetable-pagination>
            </div>
        </div>
    </div>
</template>

<script>
    import Vuetable from './Vuetable';
    import VuetablePagination from './VuetablePagination';
    import VuetablePaginationInfo from "./VuetablePaginationInfo";
    export default {
        components: {
            Vuetable,
            VuetablePagination,
            VuetablePaginationInfo,
        },
        props:{
            apiUrl: {
                type: String,
                required: true
            },
        },
        data () {
            return {
                httpHeaders: {headers: {"X-Requested-With": "XMLHttpRequest", "X-CSRF-TOKEN": window.axios.defaults.headers.common['X-CSRF-TOKEN'] }},
                fields: [
                    {
                        name: '__sequence',
                        title: '#',
                        titleClass: 'text-center sm:hidden',
                        dataClass: 'text-center  sm:hidden'
                    },
                    {
                        name: 'product_title',
                        title: 'Product',
                        titleClass: 'text-center',
                        dataClass: 'text-center',
                        sortField: 'product_id'
                    },
                    {
                        name: '__slot:image',
                        title: 'Image',
                        titleClass: 'text-center sm:hidden',
                        dataClass: 'text-center  sm:hidden',
                        sortField: 'likes'
                    },
                    {
                        name: 'price_discount',
                        title: 'Price',
                        titleClass: 'text-center sm:hidden',
                        dataClass: 'text-center  sm:hidden',
                        sortField: 'likes'
                    },
                    {
                        name: 'likes',
                        title: 'Likes',
                        titleClass: 'text-center sm:hidden',
                        dataClass: 'text-center  sm:hidden',
                        sortField: 'likes'
                    },
                    {
                        name: 'dislikes',
                        title: 'Dislikes', titleClass: 'text-center sm:hidden',
                        dataClass: 'text-center  sm:hidden',
                        sortField: 'likes'
                    },

                    {
                        name: '__slot:actions',
                        title: 'Actions',
                        titleClass: 'text-center',
                        dataClass: 'text-center',
                    }
                ],
                css: {
                    table: {
                        tableClass: 'table table-bordered table-striped table-hover',
                        ascendingIcon: '<svg class="svg-sort pl-2 fill-current" viewBox="0 0 8 8" tooltip="Sort Ascending"> <path d="M2 0v6H0l2.5 2L5 6H3V0H2zm2 0v1h2V0H4zm0 2v1h3V2H4zm0 2v1h4V4H4z"></path></svg>',
                        descendingIcon: '<svg class="svg-sort pl-2  fill-current" viewBox="0 0 8 8" tooltip="Sort Descending"> <path d="M2 0v6H0l2.5 2L5 6H3V0H2zm2 0v1h4V0H4zm0 2v1h3V2H4zm0 2v1h2V4H4z"></path></svg>'
                    },
                    pagination: {
                        wrapperClass: 'pagination',
                        activeClass: 'active',
                        disabledClass: 'disabled',
                        pageClass: 'page',
                        linkClass: 'link',
                        icons: {
                            first: '',
                            prev: '',
                            next: '',
                            last: '',
                        },
                    },
                    icons: {
                        first: 'glyphicon glyphicon-step-backward',
                        prev: 'glyphicon glyphicon-chevron-left',
                        next: 'glyphicon glyphicon-chevron-right',
                        last: 'glyphicon glyphicon-step-forward',
                    },
                },
                sortOrder: [
                    {
                        field: 'updated_at',
                        sortField: 'updated_at',
                        direction: 'desc'
                    }
                ],
                moreParams: {},
                showDeleteModal: {
                    wishlistId: null,
                    show: false
                }
            }
        },
        methods: {
            allcap (value) {
                return value.toUpperCase()
            },
            onPaginationData (paginationData) {
                this.$refs.pagination.setPaginationData(paginationData)
                this.$refs.paginationInfo.setPaginationData(paginationData)
            },
            onChangePage (page) {
                this.$refs.vuetable.changePage(page)
            },
            onCellClicked (data, field, event) {
                this.$refs.vuetable.toggleDetailRow(data.id)
            },
            deleteItemFromWishList: function(wishlistItemId){
                this.showDeleteModal.wishlistId = wishlistItemId;
                this.showDeleteModal.show = true;
            },
            performDeleteAction: function(){
                let deleteUrl = this.apiUrl+"/"+this.showDeleteModal.wishlistId;
                axios.delete(deleteUrl)
                    .then(response => {
                        var savedModel = response.data;
                        this.hideDeleteModal();
                        this.$notify({
                            group: 'notify',
                            type: 'success',
                            title: 'Product Removal Success',
                            text: 'Product has been removed from wishlist.'
                        });
                        Vue.nextTick( () => this.$refs.vuetable.refresh() );
                    }).catch(response => {
                        this.hideDeleteModal();
                        this.$notify({
                            group: 'notify',
                            type: 'error',
                            title: 'Product Removal Error',
                            text: 'Error when removing the product from the wishlist.'
                        });
                });
            },
            hideDeleteModal: function(){
                this.showDeleteModal.wishlistId = null;
                this.showDeleteModal.show = false;
            }
        }
    }
</script>
<style>
    .svg-sort{
        width:1.2rem;
    }
    .fill-white{
        fill: white;
    }
    .pagination {
        margin: 0;
        float: right;
    }
    .pagination a.page {
        border: 1px solid lightgray;
        border-radius: 3px;
        padding: 5px 10px;
        margin-right: 2px;
    }
    .pagination a.page.active {
        color: white;
        background-color: #337ab7;
        border: 1px solid lightgray;
        border-radius: 3px;
        padding: 5px 10px;
        margin-right: 2px;
    }
    .pagination a.btn-nav {
        border: 1px solid lightgray;
        border-radius: 3px;
        padding: 5px 7px;
        margin-right: 2px;
    }
    .pagination a.btn-nav.disabled {
        color: lightgray;
        border: 1px solid lightgray;
        border-radius: 3px;
        padding: 5px 7px;
        margin-right: 2px;
        cursor: not-allowed;
    }
    .pagination-info {
        float: left;
    }
</style>